% function [Aest,Best,Cest]=scand2(T,R,choix)
% T is a 3-way array, and R is its approximate rank
% The output arguments are loading matrices with R columns
% choix=1: C is Hankel (default)    => scandH  is executed
% choix=2: C is Toeplitz            => scandT  is executed
% choix=3: C is Toeplitz circulant  => scandTC is executed
%
%
% function [A,B,C]=scand(T,R)
% Computation of the CP decomposition of tensor T assuming a rank R 
% coded by P.Comon, September 2009
% Outputs: matrices with R columns
% matrix A is free but has 1's in the first line
% matrix B is free
% matrix C is Hankel with 1's in one antidiagonal
% 
%
% function [A,B,C]=scandT(T,R)
% Computation of the CP decomposition of tensor T assuming a rank R 
% coded by P.Comon, September 2009
% Outputs: matrices with R columns
% matrix A is free but has 1's in the main diagonal
% matrix B is free
% matrix C is Toeplitz with 1's in the main diagonal
% 
%
% function [A,B,C]=scandTC(T,R)
% Computation of the CP decomposition of tensor T assuming a rank R 
% coded by P.Comon, September 2009, revised June 2014
% Outputs: matrices with R columns
% matrix A is free but has 1's in the main diagonal
% matrix B is free
% matrix C is Toeplitz circulant with 1's in the main diagonal
%
%
% REFERENCE:
% "Decomposing Tensors with Structured Matrix factors reduces to rank-1 Approximations"
% ICASSP, March 2010, Dallas. Downloadable at hal-00490248
