% test.m
clear; clc; format compact;ii=sqrt(-1);

% CHOIX DES DIMENSIONS DU TENSEUR, DE SON RANG, ET DU CARACT COMPLEXE
dims=[9,8,7,5];I=dims(1);J=dims(2);K=dims(3);R=dims(4);
fprintf('-------------\n')
if R==1, error('rank is equal to 1, hence this algo is not needed'),end;
if K<R|I<R|J<R, error('rank must be smaller than dimensions'),end;
CHOIX=0; % cas complexe si CHOIX=1

% CHOIX DE LA STRUCTURE DE LA 3EME MATRICE
STRUCTURE=3; % 1=Hankel, 2=Toeplitz, 3=Toeplitz circulant

% CREATION DES MATRICES DE DONNEES ET DU TENSEUR
fprintf('Construction of data arrays\n')
RSB=50; fprintf('RSB= %g dB\n',RSB);
rbs=10^(-RSB/10);
% A est aleatoire avec des 1 sur la 1ere ligne, 
% B est aleatoire libre, 
% C est Hankel avec des 1 sur une antidiagonale
Loads=createLoadings(I,J,K,R,STRUCTURE,CHOIX);
A=Loads{1};B=Loads{2};C=Loads{3};
T=createTensor(Loads);sizT=size(T);
NN=randn(sizT);if CHOIX==1,NN=NN+ii*randn(sizT);end;
TN=T+rbs*sqrt(T(:)'*T(:))/sqrt((NN(:)'*NN(:)))*randn(sizT);
fprintf('Size of tensor: %g x %g x %g\n',sizT(1),sizT(2),sizT(3))

% CALCUL DE LA DECOMPOSITION CP
fprintf('     *** Starting computation ***\n')
[Aest,Best,Cest]=scand2(TN,R,STRUCTURE)
fprintf('     *** Computation terminated ***\n')

fprintf('Performances\n')
% VERIFICATION VISUELLE DES MATRICES
% ratioA=A./Aest, ratioB=B./Best,ratioC=C./Cest

% ERREUR DE RECONSTRUCTION
errT3=unfold(T,3)-Cest*(KR(Best,Aest)).';
fprintf('tensor reconstruction error = %7.5e\n',norm(errT3,'fro'));

% ERREUR SUR LES MATRICES
fprintf('error on A = %7.5e, error on B = %7.5e, error on C = %7.5e\n',norm(A-Aest),norm(B-Best),norm(C-Cest));
% FIN
fprintf('-------------\n')